<?php
/**
* Locale functions
*
* @package Phamm
*/

/*
* Phamm - http://phamm.rhx.it - <phamm@rhx.it>
* Copyright (C) 2004,2005 Alessandro De Zorzi and Mirko Grava
*
* This file is part of Phamm.
*  
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/**
* Set right locales from config, user input, auto...
*
* @todo
* @author Alessandro De Zorzi <adezorzi AT rhx DOT it>
*
* @return string
**/

function locale_set($language)
{
    global $supported_languages;

    if (array_key_exists($language,$supported_languages))
	return $language;
    else
	return 'en_GB';
}


/**
* Load language translation into $lang var (cached in SESSION)
*
* @author Alessandro De Zorzi <adezorzi AT rhx DOT it>
*
* @param string $language
* @return array $lang
**/

function locale_load($language)
{
    include ('../en_GB.php');

    if (file_exists('../locales/'.$language.'.php'))
	include ('../locales/'.$language.'.php');

    return $lang;
}
?>
